package com.gyee.redis2taos.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.gyee.redis2taos.entity.PointAi;
import com.gyee.redis2taos.entity.TaosEntity;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Update;

import java.sql.Timestamp;

public interface PointAiMapper extends BaseMapper<PointAi> {

    @Update("CREATE STABLE IF NOT EXISTS #{dbname}(ts timestamp,val double) TAGS(description nchar(100),station binary(20),category binary(20),equipment binary(20),uniformcode binary(20),rate float,remark binary(30))")
    int createSuperTable(String dbname);

    @Update("CREATE TABLE IF NOT EXISTS #{tbName} USING #{stbName} TAGS(#{description},#{station},#{category},#{equipment},#{uniformcode},#{rate},#{remark})")
    int createTable(@Param("tbName") String tbName, @Param("stbName") String stbName, @Param("description") String description, @Param("station") String station, @Param("category") String category, @Param("equipment") String equipment, @Param("uniformcode") String uniformcode, @Param("rate") float rate, @Param("remark") String remark);

    @Update("DROP TABLE IF EXISTS #{tbname}")
    void dropTable(String tbname);

    @Insert("INSERT INTO #{tbname}(ts, val) values(#{ts}, #{val})")
    int insertOne(@Param("tbname") String tbname, @Param("ts") Timestamp ts, @Param("val") Double val);

    @Update("ALTER TABLE #{point} SET TAG description=#{description},station=#{station},category=#{category},equipment=#{equipment},uniformcode=#{uniformcode},rate=#{rate},remark=#{remark}")
        //int alterTags(@Param("tbName") String tbName, @Param("description") String description, @Param("station") String station, @Param("category") String category, @Param("equipment") String equipment, @Param("uniformcode") String uniformcode, @Param("rate") float rate, @Param("remark") String remark);
    int alterTags(TaosEntity entity);

}
