package com.gyee.redis2taos.mapper;

import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.gyee.redis2taos.entity.Point;
import com.gyee.redis2taos.entity.PointAi;
import com.gyee.redis2taos.entity.TaosEntity;
import org.apache.ibatis.annotations.*;

import java.sql.Timestamp;
import java.util.List;

public interface PointMapper extends BaseMapper<Point> {

    @Select("SELECT DISTINCT station FROM #{stbname}")
    List<String> selectStation(String stbname);

    @Select("SELECT table_name FROM INFORMATION_SCHEMA.INS_TABLES where stable_name=#{stablename} limit #{startindex},#{endindex}")
    List<String> selectTableName(@Param("stablename") String stablename,@Param("startindex") int startindex,@Param("endindex") int endindex);

    @Select("SELECT tbname as point,description,ts,val,station,category,facility,uniformcode,rate,remark FROM ${stablename} ${ew.customSqlSegment}")
    List<Point> selectTableNamesPage(IPage<Point> page,@Param("stablename") String stablename,@Param("ew") Wrapper wrapper);

    @Update("DROP TABLE ${tablename}")
    void deleteTable(String tablename);

    @Select("SELECT * FROM ${tablename} ${ew.customSqlSegment}")
    List<Point> selectTableValPage(IPage<Point> page,@Param("tablename") String tablename,@Param("ew") Wrapper wrapper);
}
