package com.gyee.redis2taos.service;

import com.gyee.redis2taos.config.RedisConfig;
import com.gyee.redis2taos.entity.TaosEntity;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import redis.clients.jedis.Jedis;

import javax.annotation.Resource;
import java.text.SimpleDateFormat;
import java.util.*;
import java.util.stream.Collectors;

@Slf4j
@Service
public class RedisService {

    @Resource
    private FileService fileService;
    @Resource
    private RedisConfig redisConfig;

    private static final ThreadLocal<SimpleDateFormat> sdf = ThreadLocal.withInitial(() -> new SimpleDateFormat("yyyy-MM-dd HH:mm:ss"));

    public void creatTables(List<TaosEntity> entities) {
        //List<TaosEntity> excelTaos = fileService.getExcelTaos();
        //List<String> collect = entities.stream().map(te -> te.getPoint().replaceFirst(".", "_")).collect(Collectors.toList());
        List<String> collect = entities.stream().map(te -> te.getPoint()).collect(Collectors.toList());
        Map<String, String> map = null;
        Date date = new Date();
        log.info("开始redis建表！");
        try (Jedis jedis = redisConfig.getJedis();) {
            for (String excelRedi : collect) {
                if (!jedis.exists(excelRedi)) {
                    map = new LinkedHashMap<>();
                    map.put("pointid", excelRedi);
                    map.put("value", "0");
                    map.put("timestamp", String.valueOf(date.getTime() / 1000));
                    map.put("datetime", sdf.get().format(date));
                    map.put("status", "0");
                    jedis.hmset(excelRedi, map);
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        log.info("redis建表完成！");
    }

    public Set<String> getKeys() {
        return redisConfig.getJedis().keys("*");
    }
}
